#include <FK/FK.h>
#include "FKUT/TrackBall.h"
#include "FKUT/OBB.h"
#include "FKUT/FrameController.h"
#include "EventManager.h"
#include "Field.h"
#include "Player.h"

// }EẌړʂɉăJ𓮂FPSIȃA
void procMouseView(fk_Model &camera, bool lockSW)
{
	static POINT	po;
	static int		nowX, nowY, nowZ, prevX, prevY;
	static double	diffX, diffY;
	static bool		once = false;
	const double	spinRate = 0.001;
	const double	moveRate = 5.0;

	GetCursorPos(&po);	// Win32API
	if(once == false) {
		prevX = po.x;
		prevY = po.y;
		once = true;
	}
	nowZ = Fl::e_dy;
	Fl::e_dy = 0;

	nowX = po.x;
	nowY = po.y;
	diffX = nowX - prevX;
	diffY = nowY - prevY;
	camera.loAngle(diffX*spinRate, 0.0, 0.0);
	camera.loAngle(0.0, diffY*spinRate, 0.0);
	camera.glAngle(camera.getAngle().h, camera.getAngle().p, 0.0);
	camera.loTranslate(0.0, 0.0, nowZ*moveRate);
	if(lockSW == true){
		SetCursorPos(prevX, prevY);	// Win32API
	} else {
		prevX = nowX;
		prevY = nowY;
	}
}

int main(int argc, char *argv[])
{
	Fl_Window	mainWindow(800, 600, "COLLISION TEST");
	fk_Model	camera, lightModel;
	fk_Light	light;
	fk_Scene	scene;
	fk_Window	window(0, 0, 800, 600);

	CField		fieldObj;
	CPlayer		playerObj;

	fk_Vector	view, plSpd, plPos;
	fk_Matrix	rotMat;

	fk_TrackBall			tb(&window, &camera);
	fkut_FrameController	fc;
	EventManager			eve;


	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);

	// effBXvCXgɓo^
	fieldObj.entryScene(&scene);
	playerObj.entryScene(&scene);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	rotMat.makeRot(FK_PI/2.0, fk_Y);

	mainWindow.show();
	window.show();

	fk_Vector	nowPos, targetPos;
	double		cosT, rad, deg;

	while(true) {
		fc.TimeRegular();

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		/*
		if(eve.getKeyStatus('z') == FKUT_SW_PRESS) {
			targetPos = nowPos = playerModel.getPosition();
			targetPos.y = 30.0;

			playerModel.glMoveTo(nowPos*0.8 + targetPos*0.2);
		}
		*/

		tb.update();
		// procMouseView(playerModel, true);

		if(fc.GetDrawFlag()) window.drawWindow();
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		eve.update(&window, NULL);

		// J XZ Ƃɐis
		view = camera.getVec();
		view.y = 0.0;
		view.normalize();

		// L[ɂXs[hύX
		playerObj.update(&fieldObj, &eve, view);

		plSpd = playerObj.getSpd();
		camera.glTranslate(plSpd.x, 0.0, plSpd.z);

		plPos = playerObj.getModel()->getPosition();
		plPos.y = 0.0;
		tb.setLookTo(plPos);


		cosT = view*camera.getVec();
		rad = acos(cosT);
		deg = rad/FK_PI*180.0;
		plPos = playerObj.getModel()->getPosition();

		if(deg > 70.0) {
			camera.glRotateWithVec(
				plPos, plPos+rotMat*view,
				-(deg-70.0)/180.0*FK_PI);
		}
		if(deg < 10.0) {
			camera.glRotateWithVec(
				plPos, plPos+rotMat*view,
				 (10.0-deg)/180.0*FK_PI);
		}
		
	}

	return 0;
}
